package cn.com.infosec.asn1.cms;

import cn.com.infosec.asn1.ASN1Encodable;
import cn.com.infosec.asn1.ASN1EncodableVector;
import cn.com.infosec.asn1.ASN1Sequence;
import cn.com.infosec.asn1.DEREncodable;
import cn.com.infosec.asn1.DERObject;
import cn.com.infosec.asn1.DERObjectIdentifier;
import cn.com.infosec.asn1.DERSequence;

public class OtherKeyAttribute extends ASN1Encodable {
   private DERObjectIdentifier keyAttrId;
   private DEREncodable keyAttr;

   public static OtherKeyAttribute getInstance(Object o) {
      if (o != null && !(o instanceof OtherKeyAttribute)) {
         if (o instanceof ASN1Sequence) {
            return new OtherKeyAttribute((ASN1Sequence)o);
         } else {
            throw new IllegalArgumentException("unknown object in factory: " + o.getClass().getName());
         }
      } else {
         return (OtherKeyAttribute)o;
      }
   }

   public OtherKeyAttribute(ASN1Sequence seq) {
      this.keyAttrId = (DERObjectIdentifier)seq.getObjectAt(0);
      this.keyAttr = seq.getObjectAt(1);
   }

   public OtherKeyAttribute(DERObjectIdentifier keyAttrId, DEREncodable keyAttr) {
      this.keyAttrId = keyAttrId;
      this.keyAttr = keyAttr;
   }

   public DERObjectIdentifier getKeyAttrId() {
      return this.keyAttrId;
   }

   public DEREncodable getKeyAttr() {
      return this.keyAttr;
   }

   public DERObject toASN1Object() {
      ASN1EncodableVector var1;
      ASN1EncodableVector var10000 = var1 = new ASN1EncodableVector;
      var1.<init>();
      var1.add(this.keyAttrId);
      var10000.add(this.keyAttr);
      return new DERSequence(var1);
   }
}
